; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; ________________________________________________
; |       Programma scheda didattica 8 led       |
; |_________________PROGRAMMA 2__________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : ASM                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 14/01/07                       |
; |______________________________________________|

;Toggle di un'uscita con timing ~245ms utilizzando contatori

        LIST

    __CONFIG 0x2118
; Program code protection: OFF
; Data code protection: OFF
; LVP: OFF
; BODEN: OFF
; MCLRE: Vcc
; FOSC2: INTRC
; PWRT: OFF
; WDT: OFF
; FOSC1-0: RA6,RA7 = I/O
 

#include "P16F628A.inc"
#include "macro.inc"
#include "costanti.inc"

BANK_0
#include "variabili.inc"


 ORG RESET_VECTOR
;***************************************************************************
;                             START-UP SISTEMA
;***************************************************************************
SYS_STARTUP:

        CLI                             ;Disabilita master IRQ
        CLRF PORTA                      ;Inizializza PORTA
        MOVLF 0x07,CMCON                ;disabilita comparatori
        BANKSET 1                       ;Bank1
        MOVLF 0xB,PCON                  ;Setta osc. interno 4MHz
        MOVLF 0xFD,c_LED_TRIS           ;Setta pin LED come uscita
        BANKSET 0                       ;Bank0
        BSF c_LED_PORT,c_LED_PIN        ;Spegne led

;***************************************************************************
;                           PROGRAMMA PRINCIPALE
;***************************************************************************
PROGRAM:
;1 ciclo=1,25us
;program: 1 ciclo + loop2 + 5 o 6 cicli = 195846 / 195847 cicli ~ 245 ms
        MOVLF 0xFF,b_CONT1              ;carica contatore 1 (65535)
;loop2: (loop1 + 3 cicli) * 255 = 195840 cicli
LOOP2   MOVLF 0xFF,b_CONT2              ;carica contatore 2
;loop1: 3 cicli * 255 = 765
LOOP1   DECFSZ b_CONT2                  ;decrementa contatore 2
        GOTO LOOP1                      ; cicla finchè contatore 2 > 0
        DECFSZ b_CONT1                  ;decrementa contatore 1
        GOTO LOOP2                      ; cicla finchè contatore 1 > 0
        BTFSS c_LED_PORT,c_LED_PIN      ;controlla stato led
        GOTO LED_CLR                    ; clear
LED_SET BCF c_LED_PORT,c_LED_PIN        ; set-->clear
        GOTO PROGRAM                    ;torna a inizio ciclo
LED_CLR BSF c_LED_PORT,c_LED_PIN        ; clear-->set
        GOTO PROGRAM                    ;torna a inizio ciclo
        END
